﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using log4net;

namespace Tireguit.Nmon.Parser.Information
{
    public class BBBCElement:NmonInfoElement
    {
         protected new ILog _log=LogManager.GetLogger(typeof(BBBCElement));
        protected IDataParameter _numberline = null;
        protected IDataParameter _infoline = null;
        public string NumberLine { get; protected set; }
        public BBBCElement(IDbConnection connection)
        {
            Balise = BaliseType.BBBC;
            ListCommand = new List<System.Data.IDbCommand>();
            Connection = connection;
            Linestring = string.Empty;
            _insertreq="INSERT INTO "+NmonTables.TablesDictionnary.Instance["BBBC"]+" ([numberline],[diskinfo]) VALUES (@numberline,@diskinfo)";
            Command = Connection.CreateCommand();
            Command.CommandText = _insertreq;
            ListCommand.Add(Command);
            _numberline = Command.CreateParameter();
            _numberline.ParameterName = "@numberline";
            _numberline.DbType = DbType.String;
            _infoline = Command.CreateParameter();
            _infoline.ParameterName = "@diskinfo";
            _infoline.DbType = DbType.String;
        }
        public BBBCElement():this(null){}
        public override List<IDbCommand> GetInsertReq()
        {
            try
            {
                _log.Debug("start GetInsertReq");


                if (Command == null)
                {
                    Command = Connection.CreateCommand();
                    Command.CommandText = _insertreq;
                    ListCommand.Add(Command);
                }
                Command.Parameters.Clear();
                _numberline.Value = NumberLine;
                _infoline.Value = InfoLine;
                Command.Parameters.Add(_numberline);
                Command.Parameters.Add(_infoline);

                return ListCommand;

            }
            catch (System.Exception ex)
            {
                _log.Error("GetInsertReq", ex);
                return null;
            }
            finally
            {
                _log.Debug("stop GetInsertReq");
            }
        }
        protected override bool InternalParse(string line)
        {
            try
            {
                _log.Debug("start InternalParse");
                if (string.IsNullOrEmpty(line))
                {
                    return false;
                }

                // AAAElement aaaelem = new AAAElement();
                string[] elements = line.Split(separ);
#if DEBUG
                if (elements[0] != "BBBC")
                {
                    _log.Error("Not BBBC Line");
                    throw new ArgumentOutOfRangeException("start");
                }
#endif
                NumberLine = elements[1];

                InfoLine = elements[2];
                return true;
                //  return aaaelem;

            }
            catch (System.Exception ex)
            {
                _log.Error("InternalParse", ex);
                return false;
            }
            finally
            {
                _log.Debug("stop InternalParse");
            }
        }
    }
}
