﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using log4net;
using System.Globalization;

namespace Tireguit.Nmon.Parser.Statisitic
{
    public class CPU_ALLElement:NmonStatElement
    {
        protected new ILog _log=LogManager.GetLogger(typeof(CPU_ALLElement));
        protected IDataParameter _zzzz = null;
        protected IDataParameter _usertime = null;
        protected IDataParameter _systime = null;
        protected IDataParameter _waittime = null;
        protected IDataParameter _idletime = null;
        protected IDataParameter _busy = null;
        protected IDataParameter _cpus = null;
        public string Zzzz {get;protected set;}
        public float Usertime{get;protected set;}
        public float Systime { get; protected set; }
        public float Waittime { get; protected set; }
        public float Idletime {get; protected set;}
        public float? Busy {get; protected set;}
        public int Cpus {get;protected set;}
        public CPU_ALLElement(IDbConnection connection)
        {
            Balise = BaliseType.CPU_ALL;
            ListCommand = new List<System.Data.IDbCommand>();
            Connection = connection;
            Linestring = string.Empty;
            _insertreq="INSERT INTO "+NmonTables.TablesDictionnary.Instance["CPU_ALL"]+" ([zzzz],[Usertime],[Systime],[Waittime],[Idletime],[Busy],[Cpus]) VALUES (@zzzz,@Usertime,@Systime,@Waittime,@Idletime,@Busy,@Cpus)";
            Command = Connection.CreateCommand();
            Command.CommandText = _insertreq;
            ListCommand.Add(Command);
            _zzzz = Command.CreateParameter();
            _zzzz.ParameterName = "@zzzz";
            _zzzz.DbType = DbType.String;
            _usertime = Command.CreateParameter();
            _usertime.ParameterName = "@Usertime";
            _usertime.DbType = DbType.Decimal;
            _systime = Command.CreateParameter();
            _systime.ParameterName = "@Systime";
            _systime.DbType = DbType.Decimal;
            _waittime = Command.CreateParameter();
            _waittime.ParameterName = "@Waittime";
            _waittime.DbType = DbType.Decimal;
            _idletime = Command.CreateParameter();
            _idletime.ParameterName = "@Idletime";
            _idletime.DbType = DbType.Decimal;
            _busy = Command.CreateParameter();
            _busy.ParameterName = "@Busy";
            _busy.DbType = DbType.Decimal;
            _cpus = Command.CreateParameter();
            _cpus.ParameterName="@Cpus";
            _cpus.DbType = DbType.Int32;
        }
        public CPU_ALLElement():this(null){}
        public override List<IDbCommand> GetInsertReq()
        {
            try
            {
                _log.Debug("start GetInsertReq");


                if (Command == null)
                {
                    Command = Connection.CreateCommand();
                    Command.CommandText = _insertreq;
                    ListCommand.Add(Command);
                }
                Command.Parameters.Clear();
                _zzzz.Value = Zzzz;
                _usertime.Value = Usertime;
                _systime.Value = Systime;
                _waittime.Value = Waittime;
                _idletime.Value = Idletime;
                if (Busy.HasValue)
                {
                    _busy.Value = Busy.Value;
                }
                else
                {
                    _busy.Value = DBNull.Value;
                }
                _cpus.Value = Cpus;
                Command.Parameters.Add(_zzzz);
                Command.Parameters.Add(_usertime);
                Command.Parameters.Add(_systime);
                Command.Parameters.Add(_waittime);
                Command.Parameters.Add(_idletime);
                Command.Parameters.Add(_busy);
                Command.Parameters.Add(_cpus);

                return ListCommand;

            }
            catch (System.Exception ex)
            {
                _log.Error("GetInsertReq", ex);
                return null;
            }
            finally
            {
                _log.Debug("stop GetInsertReq");
            }
        }
        protected override bool InternalParse(string line)
        {
            try
            {
                _log.Debug("start InternalParse");
                if (string.IsNullOrEmpty(line))
                {
                    return false;
                }

                // AAAElement aaaelem = new AAAElement();
                string[] elements = line.Split(separ);
#if DEBUG
                if (elements[0] != "CPU_ALL")
                {
                    _log.Error("Not CPU_ALL Line");
                    throw new ArgumentOutOfRangeException("start");
                }
#endif
                if (elements[1].StartsWith("CPU"))
                {
                    //Skip information header 
                    return false;
                }
                Zzzz = elements[1];
                float res = -1;
                if(float.TryParse(elements[2],NumberStyles.Float,CultureInfo.InvariantCulture ,out res))
                {
                    Usertime = res;

                }
                if (float.TryParse(elements[3], NumberStyles.Float, CultureInfo.InvariantCulture, out res))
                {
                    Systime = res;

                }
                if (float.TryParse(elements[4], NumberStyles.Float, CultureInfo.InvariantCulture, out res))
                {
                    Waittime = res;

                }
                if (float.TryParse(elements[5], NumberStyles.Float, CultureInfo.InvariantCulture, out res))
                {
                    Idletime = res;

                }
                if (float.TryParse(elements[6], NumberStyles.Float, CultureInfo.InvariantCulture, out res))
                {
                    Busy = res;

                }
                else
                {
                    Busy = null;
                }
                int res2 = -1;
                if (int.TryParse(elements[7], out res2))
                {
                    Cpus = res2;

                }
                                
                return true;
                //  return aaaelem;

            }
            catch (System.Exception ex)
            {
                _log.Error("InternalParse", ex);
                return false;
            }
            finally
            {
                _log.Debug("stop InternalParse");
            }
        }
    }
}
